<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fibers',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'Справочник языка',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'Наследование исключений',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'Генераторы',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fibers</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Обзор файберов</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Файберы представляют собой прерываемые функции полного цикла. Файберы могут быть приостановлены из любого места цикла,
   приостанавливая выполнение в файбере до тех пор, пока файбер не будет возобновлён в будущем.
  </p>
  <p class="para">
   Файберы приостанавливают весь цикл выполнения, поэтому вызывающему функцию напрямую не нужно менять способ её вызова.
  </p>
  <p class="para">
   Выполнение может быть прервано в любом месте цикла с помощью метода <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>
   (то есть вызов <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> может находиться в глубоко вложенной функции
   или даже вообще не существовать).
  </p>
  <p class="para">
   В отличие от генераторов (<span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>) без стека, у каждого объекта <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span> есть
   свой собственный стек вызовов, позволяющий приостанавливать их внутри глубоко вложенных вызовов функций.
   Функция, объявляющая точку прерывания (то есть вызов метода <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>),
   не должна изменять свой возвращаемый тип, в отличие от функции, использующей <a href="language.generators.syntax.php#control-structures.yield" class="link"><code class="literal">yield</code></a>,
   который должен возвращать экземпляр <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>.
  </p>
  <p class="para">
   Файберы могут быть приостановлены при вызове любой функции, включая те, которые вызываются из виртуальной машины PHP,
   например, функции, предоставляемые <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span>, или методы, вызываемые <a href="control-structures.foreach.php" class="link"><code class="literal">foreach</code></a> для объекта
   <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>.
  </p>
  <p class="para">
   После приостановки выполнение файбера может быть возобновлено с любым значением с помощью метода <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span>
   или путём передачи исключения в файбер с помощью <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>.
   Значение возвращается (или выбрасывается исключение) из метода <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>.
  </p>

  <blockquote class="note"><p><strong class="note">Замечание</strong>: 
   <span class="simpara">
    До версии PHP 8.4.0 переключать файбер в <a href="language.oop5.decon.php#language.oop5.decon.destructor" class="link">деструкторе</a> объекта было невозможно.
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>Пример #1 Простой пример</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />   </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />   echo </span><span style="color: #DD0000">"Значение возобновлённого файбера: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Значение приостановленного файбера: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Результат выполнения приведённого примера:
</p></div>

   <div class="example-contents screen">
<div class="cdata"><pre>
Значение приостановленного файбера: fiber
Значение возобновлённого файбера: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>